#ifndef EO_INTERFACE_EO_HH
#define EO_INTERFACE_EO_HH
#include <Eo.h>

extern "C" {
#include "eo_interface.eo.h"
}
#include <Eina.hh>
#include <Eo.hh>
namespace eo { 
struct Interface;
} 
namespace efl { namespace eo { template<> struct is_eolian_object< ::eo::Interface> : ::std::true_type {}; } }

namespace eo_cxx {
namespace eo { 
struct Interface {
   static Eo_Class const* _eo_class()
   {
      return EO_INTERFACE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   operator ::eo::Interface() const;
   operator ::eo::Interface&();
   operator ::eo::Interface const&() const;
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interface const > operator&() const { return {this}; }
   /// @endcond
};
} 
}
namespace eo { 
struct Interface : ::efl::eo::concrete
{
   explicit Interface( ::Eo* eo)
      : ::efl::eo::concrete(eo) {}
   explicit Interface(std::nullptr_t)
      : ::efl::eo::concrete(nullptr) {}
   Interface(Interface const& other) = default;
   Interface(Interface&& other) = default;
   Interface& operator=(Interface const& other) = default;
   Interface& operator=(Interface&& other) = default;
   Interface()
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class());
   }
   Interface( ::efl::eo::concrete parent)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, parent, _eo_class());
   }
   template <typename F> Interface(F f, typename ::std::enable_if< ::efl::eolian::is_callable<F>::value>::type* = 0)
   {
      ::efl::eolian::do_eo_add( ::efl::eo::concrete::_eo_raw, ::efl::eo::concrete{nullptr}, _eo_class(), f);
   }
   static Eo_Class const* _eo_class()
   {
      return EO_INTERFACE_INTERFACE;
   }
   Eo* _eo_ptr() const { return *(Eo**)this; }
   /// @cond LOCAL
    ::efl::eolian::address_of_operator<Interface> operator&() { return {this}; }
    ::efl::eolian::address_of_operator<Interface const > operator&() const { return {this}; }
   /// @endcond
};
static_assert(sizeof(Interface) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<Interface>::value, "");
} 
#include "eo_interface.eo.impl.hh"
#endif
